---
- name: Install Docker and Docker Compose on Debian
  hosts: all
  become: yes

  tasks:
    - name: Update the package manager index
      apt:
        update_cache: yes

    - name: Install dependencies
      apt:
        name:
          - apt-transport-https
          - ca-certificates
          - curl
          - gnupg-agent
          - software-properties-common
        state: present

    - name: Add the Docker GPG key
      shell: curl -fsSL https://download.docker.com/linux/debian/gpg | apt-key add -

    - name: Add the Docker repository to the package manager
      apt_repository:
        repo: "deb [arch=amd64] https://download.docker.com/linux/debian $(lsb_release -cs) stable"
        state: present

    - name: Update the package manager index
      apt:
        update_cache: yes

    - name: Install Docker
      apt:
        name:
          - docker-ce
          - docker-ce-cli
          - containerd.io
        state: present

    - name: Add the current user to the "docker" group
      user:
        name: "{{ ansible_user_id }}"
        groups: docker
        append: yes

    - name: Install Docker Compose
      shell: curl -L "https://github.com/docker/compose/releases/download/1.29.0/docker-compose-$(uname -s)-$(uname -m)" -o /usr/local/bin/docker-compose && chmod +x /usr/local/bin/docker-compose
